#ifndef HASH_H
#define HASH_H

#include<stdlib.h>
#include<errno.h>

void memswap(void *loc0,void *loc1,int size);

#define resize(size,count,ops) (((size) * ((count) << (1))) / (ops))

typedef int (* hash_fn)(unsigned long key,int size);
typedef int (* match_fn)(void *element);
typedef unsigned long (* key_fn)(void *element);
typedef int (* fail_fn)(void *element);

#define EHRESIZE_FAIL (-1923)

int hashes;

#define HSCALE (.9)
void * hnew(int *about,int width,float scale);
#define hdispose(base) free(base)
void *hsearch(void *base,int width,int size,unsigned long key,hash_fn hash,match_fn match);
void *kihsearch(void *base,int width,int size,unsigned long key,hash_fn hash,match_fn match);
void **hresize(void **base,int width,int *size,int newsize,key_fn key,hash_fn hash,match_fn match,fail_fn fail);
void **kihresize(void **base,int width,int *size,int newsize,key_fn key,hash_fn hash,match_fn match,fail_fn fail);

int hash0(unsigned long key,int size);
int hash1(unsigned long key,int size);
int hash2(unsigned long key,int size);
int hash3(unsigned long key,int size);
int kihash0(unsigned long key,int size);
int kihash1(unsigned long key,int size);
int kihash2(unsigned long key,int size);
int kihash3(unsigned long key,int size);

unsigned long strsign(char *string);

typedef void (* freee_fn)(void *element);

struct syn {
        void *element;
        struct syn *next;
};
typedef struct syn *syn_t;

struct shptr {
       int index;
       struct syn *prev, *curr;
};
typedef struct shptr *shptr_t;

syn_t * shnew(int *size);
void shdispose(syn_t *base,int size,freee_fn freee);
#define SHSEEK_FIRST (0)
#define SHSEEK_NEXT (1)
#define SHSEEK_LAST (2)
shptr_t shseek(syn_t *base,int size,int seek,shptr_t ptr);
shptr_t shsearch(syn_t *base,int size,unsigned long key,hash_fn hash,match_fn match,shptr_t ptr);
shptr_t oshsearch(syn_t *base,int size,unsigned long key,hash_fn hash,match_fn match,shptr_t ptr);
syn_t **shresize(syn_t **base,int *size,int newsize,key_fn key,hash_fn hash);
syn_t **oshresize(syn_t **base,int *size,int newsize,key_fn key,hash_fn hash);

unsigned long keymin = 0,keymax = UINT_MAX;
int idohash(unsigned long key,int size);

#define LOG2 (.30103)
#define keydivisor(size) ((int)(log((double)size) / LOG2))
unsigned keydiv = 2;
int kdohash(unsigned long key,int size);

#endif
